uses
   Objects;

const
   BufSize=        4096;
   HeaderSize=     0;
   InputZero=      $20{80};
   OutputZero=     $80;

var
   is, os          :TBufStream;
   CurrentByte     :byte;
   NewByte         :integer;
   C               :Real;
begin
   writeln('Scream Tracker Instrument Convertor by Sasha Peslyak.');

   if ParamCount<2 then
   begin
      writeln('Usage: SCONVERT.EXE source target'); Halt;
   end;

   write('Enter multiplier (real) :'); readln(C);

   is.Init(ParamStr(1), stOpenRead, BufSize);
   os.Init(ParamStr(2), stCreate, BufSize);

   while is.Status=stOk do
   begin
      is.Read(CurrentByte, 1);

      if is.GetPos>=HeaderSize then
      begin
         NewByte:=Round((Integer(CurrentByte)-InputZero)*C)+OutputZero;
         if NewByte<0   then NewByte:=0;
         if NewByte>255 then NewByte:=255;
      end;

      if is.Status=stOk then os.Write(NewByte, 1);
   end;

   os.Done; is.Done;
end.
